/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.io.FileNotFoundException;
import java.util.*;

/**
 * @author kaizu
 */
public class Manager {
	private static Random rnd = new Random();
	private boolean studying;
	Problem[] unsolvedData;
	int unsolvedPos;
	ArrayList historyData;
	int historyPos;
	boolean isInHistory;
	ArrayList retryData;
	
	public Manager(){
		studying = false;
		unsolvedData = null;
	}
	
	public boolean isStudying(){
		return studying;
	}
	
	public void OpenFile(String filename) throws FileNotFoundException{
		Reader reader = new Reader();
		unsolvedData = (Problem[])Shuffle(reader.read(filename));
		unsolvedPos = 0;
		historyData = new ArrayList();
		isInHistory = false;
		retryData = new ArrayList();
		studying = true;
	}

	public Problem nextProblem(){
		if(isInHistory && historyPos < historyData.size()){
			Problem p = unsolvedData[historyPos];
			historyPos++;
			return p;
		}
		if(unsolvedData == null || unsolvedData.length <= unsolvedPos){
			if(retryData == null || retryData.size() == 0){
				studying = false;
				return null;
			}else{
				unsolvedData = new Problem[retryData.size()];
				Iterator it = retryData.iterator();
				for(int i=0; i<retryData.size(); i++){
					unsolvedData[i] = (Problem)it.next();
				}
				retryData.clear();
				Shuffle(unsolvedData);
				unsolvedPos = 0;
			}
		}
		Problem p = unsolvedData[unsolvedPos];
		unsolvedPos++;
		return p;
	}

	public void solved(Problem problem, boolean failed){
		if(!isInHistory){
			historyData.add(problem);
			if(failed){
				retryData.add(problem);
			}
		}
	}
	
	/**
	 * z̗̓vf_ɕёւ܂B
	 * ͔̑jIłB
	 * @param arr
	 * ёւsz
	 * @return
	 * arrԂ܂B
	 */
	public static Object[] Shuffle(Object[] arr){
		for(int i=arr.length-1; i>=0; i--) {
			int j = rnd.nextInt(i+1);
			Object temp = arr[i];
			arr[i] = arr[j];
			arr[j] = temp;
		}
		return arr;
	}
	
	public static int hitLength(String str1, String str2){
		int i;
		for(i=0; i<str1.length() && i<str2.length(); i++){
			if(str1.charAt(i) != str2.charAt(i)){
				return i;
			}
		}
		return i;
	}
}
